# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class ContentLibraryVmTemplateCreationParams(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'clusters': 'ClusterWhereInput',
        'cloud_init_supported': 'bool',
        'vm': 'VmWhereUniqueInput',
        'description': 'str',
        'name': 'str'
    }

    attribute_map = {
        'clusters': 'clusters',
        'cloud_init_supported': 'cloud_init_supported',
        'vm': 'vm',
        'description': 'description',
        'name': 'name'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """ContentLibraryVmTemplateCreationParams - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._clusters = None
        self._cloud_init_supported = None
        self._vm = None
        self._description = None
        self._name = None
        self.discriminator = None

        if "clusters" in kwargs:
            self.clusters = kwargs["clusters"]
        if "cloud_init_supported" in kwargs:
            self.cloud_init_supported = kwargs["cloud_init_supported"]
        if "vm" in kwargs:
            self.vm = kwargs["vm"]
        if "description" in kwargs:
            self.description = kwargs["description"]
        if "name" in kwargs:
            self.name = kwargs["name"]

    @property
    def clusters(self):
        """Gets the clusters of this ContentLibraryVmTemplateCreationParams.  # noqa: E501


        :return: The clusters of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :rtype: ClusterWhereInput
        """
        return self._clusters

    @clusters.setter
    def clusters(self, clusters):
        """Sets the clusters of this ContentLibraryVmTemplateCreationParams.


        :param clusters: The clusters of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :type clusters: ClusterWhereInput
        """
        if self.local_vars_configuration.client_side_validation and clusters is None:  # noqa: E501
            raise ValueError("Invalid value for `clusters`, must not be `None`")  # noqa: E501

        self._clusters = clusters

    @property
    def cloud_init_supported(self):
        """Gets the cloud_init_supported of this ContentLibraryVmTemplateCreationParams.  # noqa: E501


        :return: The cloud_init_supported of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :rtype: bool
        """
        return self._cloud_init_supported

    @cloud_init_supported.setter
    def cloud_init_supported(self, cloud_init_supported):
        """Sets the cloud_init_supported of this ContentLibraryVmTemplateCreationParams.


        :param cloud_init_supported: The cloud_init_supported of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :type cloud_init_supported: bool
        """

        self._cloud_init_supported = cloud_init_supported

    @property
    def vm(self):
        """Gets the vm of this ContentLibraryVmTemplateCreationParams.  # noqa: E501


        :return: The vm of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :rtype: VmWhereUniqueInput
        """
        return self._vm

    @vm.setter
    def vm(self, vm):
        """Sets the vm of this ContentLibraryVmTemplateCreationParams.


        :param vm: The vm of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :type vm: VmWhereUniqueInput
        """
        if self.local_vars_configuration.client_side_validation and vm is None:  # noqa: E501
            raise ValueError("Invalid value for `vm`, must not be `None`")  # noqa: E501

        self._vm = vm

    @property
    def description(self):
        """Gets the description of this ContentLibraryVmTemplateCreationParams.  # noqa: E501


        :return: The description of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ContentLibraryVmTemplateCreationParams.


        :param description: The description of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :type description: str
        """

        self._description = description

    @property
    def name(self):
        """Gets the name of this ContentLibraryVmTemplateCreationParams.  # noqa: E501


        :return: The name of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ContentLibraryVmTemplateCreationParams.


        :param name: The name of this ContentLibraryVmTemplateCreationParams.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContentLibraryVmTemplateCreationParams):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ContentLibraryVmTemplateCreationParams):
            return True

        return self.to_dict() != other.to_dict()
