# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class NodeTopoUpdationParamsData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'cluster_topo_id': 'str',
        'position': 'Position',
        'brick_topo_id': 'str'
    }

    attribute_map = {
        'cluster_topo_id': 'cluster_topo_id',
        'position': 'position',
        'brick_topo_id': 'brick_topo_id'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """NodeTopoUpdationParamsData - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._cluster_topo_id = None
        self._position = None
        self._brick_topo_id = None
        self.discriminator = None

        if "cluster_topo_id" in kwargs:
            self.cluster_topo_id = kwargs["cluster_topo_id"]
        if "position" in kwargs:
            self.position = kwargs["position"]
        if "brick_topo_id" in kwargs:
            self.brick_topo_id = kwargs["brick_topo_id"]

    @property
    def cluster_topo_id(self):
        """Gets the cluster_topo_id of this NodeTopoUpdationParamsData.  # noqa: E501


        :return: The cluster_topo_id of this NodeTopoUpdationParamsData.  # noqa: E501
        :rtype: str
        """
        return self._cluster_topo_id

    @cluster_topo_id.setter
    def cluster_topo_id(self, cluster_topo_id):
        """Sets the cluster_topo_id of this NodeTopoUpdationParamsData.


        :param cluster_topo_id: The cluster_topo_id of this NodeTopoUpdationParamsData.  # noqa: E501
        :type cluster_topo_id: str
        """

        self._cluster_topo_id = cluster_topo_id

    @property
    def position(self):
        """Gets the position of this NodeTopoUpdationParamsData.  # noqa: E501


        :return: The position of this NodeTopoUpdationParamsData.  # noqa: E501
        :rtype: Position
        """
        return self._position

    @position.setter
    def position(self, position):
        """Sets the position of this NodeTopoUpdationParamsData.


        :param position: The position of this NodeTopoUpdationParamsData.  # noqa: E501
        :type position: Position
        """

        self._position = position

    @property
    def brick_topo_id(self):
        """Gets the brick_topo_id of this NodeTopoUpdationParamsData.  # noqa: E501


        :return: The brick_topo_id of this NodeTopoUpdationParamsData.  # noqa: E501
        :rtype: str
        """
        return self._brick_topo_id

    @brick_topo_id.setter
    def brick_topo_id(self, brick_topo_id):
        """Sets the brick_topo_id of this NodeTopoUpdationParamsData.


        :param brick_topo_id: The brick_topo_id of this NodeTopoUpdationParamsData.  # noqa: E501
        :type brick_topo_id: str
        """

        self._brick_topo_id = brick_topo_id

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeTopoUpdationParamsData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NodeTopoUpdationParamsData):
            return True

        return self.to_dict() != other.to_dict()
