# coding: utf-8
try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from cloudtower.configuration import Configuration


class SecurityGroupCreateParams(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'vms': 'VmWhereInput',
        'label_groups': 'list[LabelWhereInput]',
        'description': 'str',
        'everoute_cluster_id': 'str',
        'name': 'str'
    }

    attribute_map = {
        'vms': 'vms',
        'label_groups': 'label_groups',
        'description': 'description',
        'everoute_cluster_id': 'everoute_cluster_id',
        'name': 'name'
    }

    def __init__(self, **kwargs):  # noqa: E501
        """SecurityGroupCreateParams - a model defined in OpenAPI"""  # noqa: E501
        self.local_vars_configuration = kwargs.get("local_vars_configuration", Configuration.get_default_copy())

        self._vms = None
        self._label_groups = None
        self._description = None
        self._everoute_cluster_id = None
        self._name = None
        self.discriminator = None

        if "vms" in kwargs:
            self.vms = kwargs["vms"]
        if "label_groups" in kwargs:
            self.label_groups = kwargs["label_groups"]
        if "description" in kwargs:
            self.description = kwargs["description"]
        if "everoute_cluster_id" in kwargs:
            self.everoute_cluster_id = kwargs["everoute_cluster_id"]
        if "name" in kwargs:
            self.name = kwargs["name"]

    @property
    def vms(self):
        """Gets the vms of this SecurityGroupCreateParams.  # noqa: E501


        :return: The vms of this SecurityGroupCreateParams.  # noqa: E501
        :rtype: VmWhereInput
        """
        return self._vms

    @vms.setter
    def vms(self, vms):
        """Sets the vms of this SecurityGroupCreateParams.


        :param vms: The vms of this SecurityGroupCreateParams.  # noqa: E501
        :type vms: VmWhereInput
        """

        self._vms = vms

    @property
    def label_groups(self):
        """Gets the label_groups of this SecurityGroupCreateParams.  # noqa: E501


        :return: The label_groups of this SecurityGroupCreateParams.  # noqa: E501
        :rtype: list[LabelWhereInput]
        """
        return self._label_groups

    @label_groups.setter
    def label_groups(self, label_groups):
        """Sets the label_groups of this SecurityGroupCreateParams.


        :param label_groups: The label_groups of this SecurityGroupCreateParams.  # noqa: E501
        :type label_groups: list[LabelWhereInput]
        """
        if (self.local_vars_configuration.client_side_validation and
                label_groups is not None and len(label_groups) < 1):
            raise ValueError("Invalid value for `label_groups`, number of items must be greater than or equal to `1`")  # noqa: E501

        self._label_groups = label_groups

    @property
    def description(self):
        """Gets the description of this SecurityGroupCreateParams.  # noqa: E501


        :return: The description of this SecurityGroupCreateParams.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SecurityGroupCreateParams.


        :param description: The description of this SecurityGroupCreateParams.  # noqa: E501
        :type description: str
        """

        self._description = description

    @property
    def everoute_cluster_id(self):
        """Gets the everoute_cluster_id of this SecurityGroupCreateParams.  # noqa: E501


        :return: The everoute_cluster_id of this SecurityGroupCreateParams.  # noqa: E501
        :rtype: str
        """
        return self._everoute_cluster_id

    @everoute_cluster_id.setter
    def everoute_cluster_id(self, everoute_cluster_id):
        """Sets the everoute_cluster_id of this SecurityGroupCreateParams.


        :param everoute_cluster_id: The everoute_cluster_id of this SecurityGroupCreateParams.  # noqa: E501
        :type everoute_cluster_id: str
        """
        if self.local_vars_configuration.client_side_validation and everoute_cluster_id is None:  # noqa: E501
            raise ValueError("Invalid value for `everoute_cluster_id`, must not be `None`")  # noqa: E501

        self._everoute_cluster_id = everoute_cluster_id

    @property
    def name(self):
        """Gets the name of this SecurityGroupCreateParams.  # noqa: E501


        :return: The name of this SecurityGroupCreateParams.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SecurityGroupCreateParams.


        :param name: The name of this SecurityGroupCreateParams.  # noqa: E501
        :type name: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SecurityGroupCreateParams):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SecurityGroupCreateParams):
            return True

        return self.to_dict() != other.to_dict()
